ZOJ 3802 Easy 2048 Again 状压DP

直接从前往后DP,因为一共只有500个数,所以累加起来的话单个数不会超过4096,并且因为是Flappy 2048的规则,所以只有之后数列末尾一串递减的是有效的,因此可以状压。

1700ms = =,据说用滚动数组优化一下会好很多

#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <cstdlib>
#include <climits>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <stack>
#include <sstream>
#include <numeric>
#include <fstream>
#include <functional>

using namespace std;

#define MP make_pair
#define PB push_back
typedef long long LL;
typedef unsigned long long ULL;
typedef vector<int> VI;
typedef pair<int,int> pii;
const int INF = INT_MAX / 3;
const double eps = 1e-8;
const LL LINF = 1e17;
const double DINF = 1e60;
const int maxn = 505;
const int maxs = (4096 + 5);
int num[maxn],n;
int f[maxn][maxs];

inline int lowbit(int x) {
    return x & -x;
}

void solve() {
    memset(f,-1,sizeof(f));
    f[0][0] = 0;
    int ans = 0;
    for(int i = 1;i <= n;i++) {
        for(int j = 0;j < 4096;j++) if(f[i - 1][j] != -1) {
            int nownum = num[i], nowst = j, nowval = nownum;
            f[i][j] = max(f[i][j], f[i - 1][j]);
            while(lowbit(nowst) == (nownum >> 1)) {
                nowval += (nownum << 1);
                nowst ^= (nownum >> 1);
                nownum <<= 1;
            }
            if(lowbit(nowst) < (nownum >> 1)) nowst = 0;
            nowst |= (nownum >> 1);
            f[i][nowst] = max(f[i][nowst],f[i - 1][j] + nowval);
        }
    }
    for(int i = 0;i < 4096;i++) ans = max(ans,f[n][i]);
    printf("%d\n",ans);
}

int main() {
    int T; scanf("%d",&T);
    while(T--) {
       scanf("%d",&n);
       for(int i = 1;i <= n;i++) {
           scanf("%d",&num[i]);
       }
       solve();
    }
    return 0;
}
时间: 2024-10-26 23:38:53

ZOJ 3802 Easy 2048 Again 状压DP的相关文章

ZOJ 3471 Most Powerful(状压DP)

Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappears and a lot of power is produced. Researchers know the way every two at

Codeforces Round #568 (Div. 2) G1. Playlist for Polycarp (easy version) (状压dp)

题目:http://codeforces.com/contest/1185/problem/G1 题意:给你n给选项,每个选项有个类型和价值,让你选择一个序列,价值和为m,要求连续的不能有两个相同的类型,相同的物]品不一样的顺序代表不同,问有多少个序列 思路:首先范围是15个,这里我们可以用状压来代表选择哪些物品,然后这里是说不能有连续相同的类型,这里我们贪心考虑不全,最开始我考虑的是组合数的插空法,当时 发现有很多细节,写不了,这样的话我们就只能改成dp, 我们设置dp[i][j]   代表i

ZOJ 3802 Easy 2048 Again 状态DP

zoj 上次的月赛题,相当牛的题目啊,根本想不到是状态压缩好吧 有个预先要知道的,即500个16相加那也是不会超过8192,即,合并最多合并到4096,只有2的12次方 所以用状态压缩表示前面有的序列组合,找到了符合的,就往上累加合并生成新状态,否则就添加到前面的状态的后面构成新状态,因为每一个的状态都由前一个所得,用滚动数组即可 #include <iostream> #include <cstdio> #include <cstring> #include <

ZOJ 2563 Long Dominoes(状压DP)

给定一个m*n的方格子,要求用3*1的骨牌去覆盖,骨牌可以用横放或者竖放,问最终有多少种放置方式,将其铺满. 分析:由于最多30行,每行最多9列,所以可以按行来dp,设计每行的状态从而进行转移,考虑每个骨牌放置对下一行的影响,共有0,1,2,3种方式,0对应横放或者竖放时最下面那 个格子,此行对下一行没有影响,1,竖放时第1个,2竖放时第2个,这样进行转移.注意,第i行横放时要求上一行相应位置状态为0. 思路及代码都来自这里,其实不会做这题,看了才了解. 代码: 1 #include <bits

ZOJ 3802 Easy 2048 Again ( 状态压缩 )

题目链接~~> 做题感悟:这题很经典 ,需要模拟一下找规律,还是那句话遇到题自己应该手动推一下. 解题思路: 这题如果手动推几组数据的话就应该发现 ,如果放进队列的元素是递减的话,这样才可以连续合并,如果队列中有 a  ,b , a < b 那么 a 前面的必定不会与 b 经过合并再合并,因为越合并越大,so ~> 队列中最多才存 12 个数,可以用状态压缩压缩一下.注意要用滚动数组,不用可能超时. 代码: #include<iostream> #include<sst

ZOJ 2563 Long Dominoes(状压DP)题解

题意:n*m的格子,用1 * 3的矩形正好填满它,矩形不能重叠,问有几种填法 思路:poj2411进阶版.我们可以知道,当连续两行的摆法确定,那么接下来的一行也确定.当第一行还有空时,这时第三行必须要用3 * 1的去填:当第一行没有空第二行有空时,第三行必须不填:当第一行有空第二行没空,这种不能存在:当前两行没空时,我最多就是填1 * 3的方块. 代码: #include<set> #include<map> #include<cmath> #include<qu

状压DP [ZOJ 3471] Most Powerful

Most Powerful Time Limit: 2 Seconds      Memory Limit: 65536 KB Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappears and a

ZOJ3802 Easy 2048 Again (状压DP)

ZOJ Monthly, August 2014 E题 ZOJ月赛 2014年8月 E题 http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=5334 Easy 2048 Again Time Limit: 2 Seconds      Memory Limit: 65536 KB Dark_sun knows that on a single-track road (which means once he passed this

zoj3802:easy 2048 again(状压dp)

zoj月赛的题目,非常不错的一个状压dp.. 题目大意是一个一维的2048游戏 只要有相邻的相同就会合并,合并之后会有奖励分数,总共n个,每个都可以取或者不取 问最终得到的最大值 数据范围n<=500 , a[i]={2,4,8,16}: 分析: 首先明确一下自动合并的意思,比如原有 8,4,2,进入一个2 就会变成16 所以我们需要记录前面的所有数字..计算了一下发现最大情况,500个16会合成4096 =2^12 显然全部记录是不可能的.那么怎么处理呢 我们发现,只有递减的序列才有可能向前合